﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml.Linq;
using C1.C1Schedule;
using C1.Win.C1Schedule;

namespace GanttChartScheduler
{
    public partial class Form1 : Form
    {
        string fileName = AppDomain.CurrentDomain.BaseDirectory + "ganttview.xml";
        public Form1()
        {
            InitializeComponent();
        }

        private void c1GanttView1_Load(object sender, EventArgs e)
        {
            c1GanttView1.LoadXml(fileName);
        }
        
        private void c1Schedule1_Load(object sender, EventArgs e)
        {
            this.c1Schedule1.ViewType = C1.Win.C1Schedule.ScheduleViewEnum.MonthView;
            XElement allData = XElement.Load(fileName);
                var query = allData.Descendants("task")
                    .Select(task => new
                     {
                         Name = (string)task.Attribute("name"),
                         Start = (DateTime)task.Attribute("start"),
                         Finish = (DateTime?)task.Attribute("finish"),
                         Duration = (long?)task.Attribute("duration"),
                     });

                foreach (var item in query)
                {
                    Appointment app;
                    app = c1Schedule1.DataStorage.AppointmentStorage.Appointments.Add();
                    app.Subject = item.Name;
                    app.Start = item.Start;
                    if (item.Finish != null)
                    {
                        app.End = item.Finish.Value;
                    }
                    if (item.Duration != null)
                    {
                       DateTime test = item.Start;
                        double weekends = 0;
                        for (int i = 0; i <= item.Duration+weekends; i++)
                        {
                            if (test.Date.DayOfWeek.Equals(DayOfWeek.Saturday) || test.Date.DayOfWeek.Equals(DayOfWeek.Sunday))
                            {
                                weekends++;
                                test = test.AddDays(1);
                            }
                            else
                                test = test.AddDays(1);
                        }
                        app.End = item.Start.AddDays(item.Duration.Value+weekends);
                    }
                }
        }
    }

}

